# Certificate check and recreate script
# 08.01.2016 - Alexander Ganser

# LOG Settings

LOG="/var/log/cert_check_create.log";
TIMESTAMP="$(date +"%d.%m.%Y") $(date +"%H:%M")"
MAIL="YOURMAIL@YOURDOMAIN.com"

# Certificate Paths
# LE_CERT / LE_KEY = Let's Encrypt Certificate and Key
# CERT = Certificate and Key combined

CERT="/certs/www.YOURDOMAIN.com.pem";
CERT_BAK=$CERT".bak";
LE_CERT="/etc/letsencrypt/live/www.YOURDOMAIN.com/cert.pem";
LE_KEY="/etc/letsencrypt/live/www.YOURDOMAIN.com/privkey.pem";

# Lifetime / if lifetime is longer than LTIME nothing happens
# With 2592000 the certificate is renewed every 60days
# With 5184000 the certificate is renewed every 30days

LTIME="2592000"

# Script

if openssl x509 -checkend $LTIME -noout -in $CERT
then
        echo $TIMESTAMP "Check: The Certificate is good for over 30days!" >> $LOG
        # uncomment if you want statusmails
        #echo $TIMESTAMP "Check: The Certificate is good for over 30days!" | mail -s "INFO: GOOD - Let's Encrypt Cert" $MAIL
else
        echo $TIMESTAMP "Check: The Certificate must be renewed!" >> $LOG
        # uncomment if you want statusmails
        #echo $TIMESTAMP "Check: The Certificate must be renewed!" | mail -s "INFO: RENEW - Let's Encrypt Cert" $MAIL
        cd /letsencrypt
        /letsencrypt/letsencrypt-auto -c /etc/letsencrypt/cli.ini certonly
        if [ $? -ne 0 ]
        then
                ERRORLOG=`tail /var/log/letsencrypt/letsencrypt.log`
                echo $TIMESTAMP "The Let's Encrypt Cert has not been renewed!" >> $LOG
                echo $TIMESTAMP "There was an error with Let's Encrypt"\n \n $ERRORLOG  >> $LOG
                # uncomment if you want statusmails
                #echo $TIMESTAMP "There was an error with Let's Encrypt"\n \n $ERRORLOG | mail -s "WARNING: ERROR - Let's Encrypt Cert" $MAIL
        else
                # uncomment if you want statusmails
                #echo $TIMESTAMP "The Let's Encrypt Cert has been renewed! \n \n" $ERRORLOG | mail -s "INFO: RENEWED - Let's Encrypt Cert" $MAIL
                mv $CERT $CERT_BAK
                cat $LE_CERT $LE_KEY > $CERT
                /usr/local/sbin/cert_replace_on_KEMP.sh
        fi
fi
exit 0